# accounts.admin.py
from django.contrib import admin
from django.contrib.auth.admin import UserAdmin as BaseUserAdmin


from .forms import UserAdminCreationForm, UserAdminChangeForm
from .models import User, Profile
from django.forms.models import BaseInlineFormSet


class UserAdmin(BaseUserAdmin):
    # The forms to add and change user instances
    form = UserAdminChangeForm
    add_form = UserAdminCreationForm

    # The fields to be used in displaying the User model.
    # These override the definitions on the base UserAdmin
    # that reference specific fields on auth.User.
    list_display = ('full_name', 'shenfen', 'email', 'admin',)
    list_filter = (
        'admin',
        'shenfen'
    )
    fieldsets = (
        (None, {'fields': ('email', 'password')}),
        ('Personal info', {'fields': ('identify','full_name','unit','shenfen')}),
        ('Permissions', {
        					'fields': (
		        				'active',
				            	'admin'
		            		)
        				}),
    )
    # add_fieldsets is not a standard ModelAdmin attribute. UserAdmin
    # overrides get_fieldsets to use this attribute when creating a user.
    []

    add_fieldsets = (
        (None, {
	            'classes': ('wide',),
	            'fields': (
		            	'email',
		            	'password1',
		            	'password2',
		            	'identify',
		            	'full_name',
		            	'unit',
                        'shenfen',
		            	'active',
		            	'admin'
	            	)
	            }
        ),
    )
    search_fields = ('email',)
    ordering = ('admin',)
    filter_horizontal = ()


admin.site.register(User, UserAdmin)
admin.site.register(Profile)



# Remove Group Model from admin. We're not using it.
