from django.db import models

# Create your models here.

from accounts.models import User
from tempSales.models import TempSales
from sales.models import Sales
from salesUnit.models import SalesUnit

class Application(models.Model):
    status_opt = (
            ('編輯中', '編輯中'), #0
            ('待審核', '待審核'), #1
            ('待補紙本', '待補紙本'), #2
            ('待審退回', '待審退回'), #3
            ('紙本有誤', '紙本有誤'), #4
            ('申請完成', '申請完成'), #5
            ('刪除', '刪除') #6
        )

    timeStamp = models.DateTimeField(auto_now_add=True)
    updated   = models.DateTimeField(auto_now=True)
    user = models.ForeignKey(User, blank=True, null=True)
    unit = models.ForeignKey(SalesUnit, blank=True, null=True)
    status = models.CharField(max_length=20, choices=status_opt, blank=True, null=True)
    tempSales    = models.ForeignKey(TempSales, blank=True, null=True)
    use_choice   = (
        	('新增業務','新增業務'),
        	('修改資料','修改資料')
        )

    use          = models.CharField(max_length=10, choices=use_choice, blank=True, null=True)
    origin_user  = models.ForeignKey(Sales, blank=True, null=True)
    explainText  = models.CharField(max_length=500, blank=True, null=True)
    modifiedText = models.CharField(max_length=500, blank=True, null=True)

    def __str__(self):              # __unicode__ on Python 2
        return str(self.use)

    # def has_perm(self, perm, obj=None):
    #     #"Does the user have a specific permission?"
    #     # Simplest possible answer: Yes, always
    #     return True
    #
    # def has_module_perms(self, app_label):
    #     #"Does the user have permissions to view the app `app_label`?"
    #     # Simplest possible answer: Yes, always
    #     return True
