from django.shortcuts import render
from .serializers import CompanySerializer
from .models import Company

from rest_framework import generics, viewsets
from rest_framework.permissions import IsAuthenticated
# Create your views here.
class CompanyViewSet(viewsets.ModelViewSet):
    queryset = Company.objects.all()
    serializer_class = CompanySerializer
    permission_classes = (IsAuthenticated,)


class CompanyList(generics.ListAPIView):
    serializer_class = CompanySerializer
    permission_classes = (IsAuthenticated,)
    def get_queryset(self):
        """
        Optionally restricts the returned purchases to a given user,
        by filtering against a `username` query parameter in the URL.
        """
        queryset = Company.objects.all()
        query_salesUnit = self.kwargs.get('salesUnit', None)
        if (query_salesUnit is not None) or (type(query_salesUnit) != type(1)):
            queryset = queryset.filter(salesUnit=query_salesUnit)
        return queryset
