from django.db import models

from accounts.models import User
from sales.models import Sales
from application.models import Application

from jsonfield import JSONField, JSONCharField

class LogForSalesData(models.Model):
    created          = models.DateTimeField(auto_now_add=True)
    updated_data     = JSONField(blank=True, null=True)
    orignal_sales    = models.ForeignKey(Sales)
    whoEdit          = models.ForeignKey(User)
    full_name     = models.CharField(max_length=50, blank=True, null=True)
    def __str__(self):
        return str(self.id)

class LogForUserBehavior(models.Model):
    application   = models.ForeignKey(Application, null=True, blank=True)
    created       = models.DateTimeField(auto_now=True)
    user          = models.ForeignKey(User, null=True, blank=True)
    full_name     = models.CharField(max_length=50, blank=True, null=True)
    behavior      = models.CharField(max_length=50, blank=True, null=True)
    def __str__(self):
        return str(self.id)

# from django.dispatch import receiver
# from django.db.models.signals import post_save
# from testapp.models import Test
# from accounts.models import User
# from company.models import Company
#
# @receiver(post_save, sender=User, dispatch_uid="test_post_save")
# @receiver(post_save, sender=Company, dispatch_uid="test_post_save")
# @receiver(post_save, sender=Test, dispatch_uid="test_post_save")
# def my_model_handler(sender, **kwargs):
#     print('Saved: {}'.format(kwargs['instance'].__dict__))
# Create your models here.
