from django.shortcuts import render
from rest_framework import generics, viewsets
from rest_framework.permissions import IsAuthenticated
from tempSales.models import TempSales
from salesUnit.models import SalesUnit

from .models import modified
from .serializers import ModifiedListAPISerializer, ModifiedSerializer

import datetime
import pytz
from itertools import chain
# Create your views here.
class ModifiedViewSet(viewsets.ModelViewSet):
    queryset = modified.objects.all()
    serializer_class = ModifiedSerializer
    permission_classes = (IsAuthenticated,)

class ModifiedListAPI(generics.ListAPIView):
    serializer_class = ModifiedListAPISerializer
    permission_classes = (IsAuthenticated,)
    def get_queryset(self):
        """
        Optionally restricts the returned purchases to a given user,
        by filtering against a `username` query parameter in the URL.
        """
        user = self.request.user
        unit = []
        state = []
        sales = self.request.GET.get("sales", None)
        if not sales:
            try:
                for i in self.request.GET.get("unit", None).split(","):
                    unit.append((int)(i))
                for i in self.request.GET.get("state", None).split(","):
                    state.append(i)
            except:
                pass
            start = self.request.GET.get("start", None)
            end = self.request.GET.get("end", None)
            if unit != [] and state != []:
                if user.shenfen == "salesHumanResources" or user.shenfen == "humanResources":
                    queryset = modified.objects.filter()
                else:
                    queryset = modified.objects.filter(user=user)
                unitQuery = []
                stateQuery = []
                date_format = '%Y-%m-%d'
                for i in unit:
                    unitQuery.append(queryset.filter(sales_unit=SalesUnit.objects.get(id=i).display_name))
                queryset = unitQuery[0]
                for i in unitQuery:
                    queryset = queryset | i
                for i in state:
                    stateQuery.append(queryset.filter(change=i))
                queryset = stateQuery[0]
                for i in stateQuery:
                    queryset = queryset | i
                unaware_start_date = datetime.datetime.strptime(start or "2000-01-01", date_format)
                if end:
                    unaware_end_date = datetime.datetime.strptime(end, date_format)
                else:
                    unaware_end_date = datetime.datetime.today()
                aware_start_date = pytz.utc.localize(unaware_start_date)
                aware_end_date = pytz.utc.localize(unaware_end_date)
                queryset = queryset.filter(created__range=(aware_start_date,aware_end_date))
                return queryset
            else:
                if user:
                    if user.shenfen == "salesHumanResources" or user.shenfen == "humanResources":
                        queryset = modified.objects.filter()
                    else:
                        queryset = modified.objects.filter(user=user)
                    wanted_items = set()
                    for i in queryset:
                        print(i)
                        if i.created.date() == datetime.date.today():
                            wanted_items.add(i.id)
                    return modified.objects.filter(id__in = wanted_items)
                else:
                    return []
        else:
            if user.shenfen == "salesHumanResources" or user.shenfen == "humanResources":
                queryset = modified.objects.filter()
            else:
                queryset = modified.objects.filter(user=user)
            return queryset.filter(orignal_sales=sales)
