from django.db import models

from application.models import Application

class Notification(models.Model):
    application    = models.ForeignKey(Application, blank=True, null=True)
    created        = models.DateTimeField(auto_now_add=True, blank=True, null=True)
    update         = models.DateTimeField(auto_now_add=True, blank=True, null=True)

    sales_name     = models.CharField(max_length=20, blank=True, null=True)
    sales_id       = models.CharField(max_length=20, blank=True, null=True)
    unit           = models.CharField(max_length=20, blank=True, null=True)
    company        = models.CharField(max_length=20, blank=True, null=True)
    sales_type     = models.CharField(max_length=20, blank=True, null=True)
    sales_position = models.CharField(max_length=20, blank=True, null=True)

    app_status     = models.CharField(max_length=20, blank=True, null=True)
    change         = models.CharField(max_length=500, blank=True, null=True)

    display_opt    = (
            ('顯示', '顯示'),
            ('不顯示', '不顯示')
        )

    display       = models.CharField(max_length=20, default=display_opt[0][0], blank=True, null=True, choices=display_opt)

    def __str__(self):
        return self.sales_name + "-" + self.app_status
