from django.shortcuts import render
from rest_framework import generics, viewsets
from rest_framework.permissions import IsAuthenticated
from tempSales.models import TempSales
from salesUnit.models import SalesUnit

from .models import Notification
from .serializers import NotificationListAPISerializer, NotificationSerializer

from itertools import chain
# Create your views here.
class NotificationViewSet(viewsets.ModelViewSet):
    queryset = Notification.objects.all()
    serializer_class = NotificationSerializer
    permission_classes = (IsAuthenticated,)

class NotificationListAPI(generics.ListAPIView):
    serializer_class = NotificationListAPISerializer
    permission_classes = (IsAuthenticated,)
    def get_queryset(self):
        """
        Optionally restricts the returned purchases to a given user,
        by filtering against a `username` query parameter in the URL.
        """
        queryset = Notification.objects.all()
        # serializer = ApplicationSerializer(queryset, many=True)
        user = self.request.user
        if user:
            unit_id = []
            result = []
            for i in user.unit.all():
                unit_id.append(i.id)
            for i in unit_id:
                result.append(queryset.filter(application__tempSales__sales_unit=(int(i)),display="顯示"))
            output = result[0]
            for i in result:
                output = output | i
            return output
        return []
