from django.contrib import admin

from .models import Sales


class SalesAdmin(admin.ModelAdmin):
    # The forms to add and change user instances

    # The fields to be used in displaying the User model.
    # These override the definitions on the base UserAdmin
    # that reference specific fields on auth.User.
    raw_id_fields = ("immediate_supervisor", )
    list_display = ('full_name', "sales_unit", 'sales_id', 'state', 'id')
    list_filter = ("position", "state", "sales_unit")
    # add_fieldsets is not a standard ModelAdmin attribute. UserAdmin
    # overrides get_fieldsets to use this attribute when creating a user.
    []
    search_fields = ('full_name', 'sales_id')
    ordering = ('full_name', 'sales_unit', 'sales_id', 'state', 'id')


admin.site.register(Sales, SalesAdmin)

# Register your models here.
