from django.contrib import admin
from django.db import models

from .models import SalesUnit

class SalesUnitAdmin(admin.ModelAdmin):
    # The forms to add and change user instances

    # The fields to be used in displaying the User model.
    # These override the definitions on the base UserAdmin
    # that reference specific fields on auth.User.

    list_display = ('display_name', 'level', 'unit_type')
    list_filter = (
        'level','unit_type',
    )

    # add_fieldsets is not a standard ModelAdmin attribute. UserAdmin
    # overrides get_fieldsets to use this attribute when creating a user.

    search_fields = ('display_name',)
    ordering = ('unit_type',)
    filter_horizontal = ()

# Remove Group Model from admin. We're not using it.

admin.site.register(SalesUnit, SalesUnitAdmin)
# Register your models here.
