from django.db import models

# Create your models here.

# Create your models here.
class SalesUnit(models.Model):
    unit_num = models.CharField(
            max_length=255,
            unique=True
        )

    unit_name = models.CharField(
        	max_length=255,
        	unique=True
        )

    level_rank = (
            ('Rank A', 'Rank A'),
            ('Rank B', 'Rank B'),
            ('Rank C', 'Rank C'),
        )

    unit_type_choice = (
            ('總公司', '總公司'),
            ('業務單位', '業務單位'),
            ('書局通路', '書局通路'),
        )

    display_name = models.CharField(
    	   max_length=255,
    	   null=True
        )

    unit_type  = models.CharField(
            max_length=8,
            choices=unit_type_choice
        )

    level = models.CharField(
            max_length=6,
            choices=level_rank
        )
    html_name_value = models.CharField(
            max_length=30,
            null=True,
            blank=True
        )
    # notice the absence of a "Password field", that's built in.

    REQUIRED_FIELDS = ['unit_num', 'unit_name'] # Email & Password are required by default.
    def save(self, *args, **kw):
        self.display_name = self.unit_num + ' ' + self.unit_name
        super(SalesUnit, self).save(*args, **kw)

    def get_full_name(self):
        # The user is identified by their email address
        return self.display_name

    def get_short_name(self):
        # The user is identified by their email address
        return self.display_name

    def __str__(self):              # __unicode__ on Python 2
        return self.display_name
