from django import forms

class ContactForm(forms.Form):
	fullname = forms.CharField(
			widget=forms.TextInput(
				attrs={
					"class": "form-control",
					"placeholder":"Your full name",
					#"id": "form_full_name"
					}
			)
	)
	email    = forms.EmailField(
			widget=forms.EmailInput(
				attrs={
					"class": "form-control",
					"placeholder":"Your email",
					#"id": "form_full_name"
					}
			)
	)
	content  = forms.CharField(
			widget=forms.Textarea(
					attrs={
						'class': 'form-control',
						'placeholder':'Your message'
					}
				)
	)
	def clean_fullname(self):
		fullname = self.cleaned_data.get('fullname')
		return fullname
	def clean_email(self):
		email = self.cleaned_data.get('email')
		return email
	def clean_content(self):
		content = self.cleaned_data.get('content')
		return content


class LoginForm(forms.Form):
	error_css_class = 'error'
	username = forms.EmailField(
			label="信箱",
			widget=forms.EmailInput(
				attrs={
					"class": "login-input login-account",
					"placeholder":"請輸入登入帳號",
					#"id": "form_full_name"
					}
			)
	)
	password = forms.CharField(
			label="密碼",
			widget=forms.PasswordInput(
				attrs={
					"class": "login-input login-password",
					"placeholder": "請輸入登入密碼",
					}
			)
		)
