from django.db import models
from django.utils import timezone
from django.core.files.uploadedfile import SimpleUploadedFile
from django.core.files.base import ContentFile

from accounts.models import User

from PIL import Image
import os, random
from io import BytesIO


def get_filename_ext(filepath):
	base_name = os.path.basename(filepath)
	name, ext = os.path.splitext(base_name)
	return name, ext


# Create your models here.
# class ColtestManage(models.Manager):
# 	def create_col(self, title, imageFile1, imageFile2):
# 		col = self.create(title=title, picfile1=imageFile1, picfile2=imageFile2)
# 		return col


class CustomImageField(models.ImageField):
	def __init__(self, contract_type=None, *args, **kwargs):
		self.contract_type = contract_type
		super(CustomImageField, self).__init__(*args, **kwargs)

class Test(models.Model):
	# objects = ColtestManage()
	created = models.DateTimeField('建立時間', auto_now=True)
	user = models.ForeignKey(User,null=True,blank=True)
	title = models.CharField('標題',max_length=255,default="123")
	img1 = CustomImageField(contract_type='test',null=True,blank=True)
	img1_thumb = CustomImageField(contract_type='test.thumb',null=True,blank=True)
	img1_datetime = models.DateTimeField(null=True,blank=True)
	img2 = models.ImageField(null=True,blank=True)
	img2_datetime = models.DateTimeField(null=True,blank=True)
	pdf = models.FileField(upload_to='pdf/',null=True,blank=True)
	def __init__(self, *args, **kwargs):
		super(Test, self).__init__(*args, **kwargs)
		self.__original_title = self.title
		self.__original_img1 = self.img1
		self.__original_img2 = self.img2

	def upload_image_path(self, filename, contract_type, *arg, **kwargs):
		isThumb = ''
		if 'thumb' in contract_type:
			isThumb = 'thumb_'
		new_filename = isThumb + str(random.randint(1,3910209312))
		name, ext = get_filename_ext(filename)
		final_filename = '{new_filename}{ext}'.format(new_filename=new_filename, ext=ext)
		return "image/{new_filename}/{contract_type}/{final_filename}".format(
				new_filename=self.title,
				contract_type=contract_type.split('.')[0],
				final_filename=final_filename
				)

	def saveThumb(self, self_origin, self_thumb):
		size = 145, 205
		im = Image.open(getattr(self, self_origin))
		origin_image_io = BytesIO()
		im.save(origin_image_io, format=im.format)
		getattr(self, self_origin).save(
				Test.upload_image_path(self, getattr(self, self_origin).name.split('/')[-1], getattr(self, self_origin).field.contract_type),
				content=ContentFile(origin_image_io.getvalue()),
				save=False
		)
		width = im.width
		height = im.height

		if ((width/height)*205) > 145:
			newWidth = 145
			newHeight = 145 * (height/width)
		else:
			newHeight = 205
			newWidth  = (width/height) * 205

		new_image_io = BytesIO()
		new_image = im.resize(((int)(newWidth), (int)(newHeight)), Image.ANTIALIAS)
		new_image.save(new_image_io, format=im.format)
		getattr(self, self_thumb).save(
				Test.upload_image_path(self, getattr(self, self_origin).name.split('/')[-1], getattr(self, self_thumb).field.contract_type),
				content=ContentFile(new_image_io.getvalue()),
				save=False
		)
	def save(self, force_insert=False, force_update=False, using=None, api=False ,*args, **kwargs):
		argsDict = (('img1', self.__original_img1, 'img1_thumb', 'img1_datetime'), )
		if api == 'Create':
			print("Create")
			for i in argsDict:
				if getattr(self, i[0]) != None:
					Test.saveThumb(self, i[0], i[2])
					setattr(self, i[3], timezone.now())
		elif api == 'Update':
			print("Update")
			for i in argsDict:
				if getattr(self, i[0]) != i[1]:
					if getattr(self, i[0]) != None:
						Test.saveThumb(self, i[0], i[2])
						setattr(self, i[3], timezone.now())
		else:
			for i in argsDict:
				if getattr(self, i[0]) != i[1]:
					print("admin")
					Test.saveThumb(self, i[0], i[2])
					setattr(self, i[3], timezone.now())
		# if self.img1 != self.__original_img1:
		# 	self.img1_datetime = timezone.now()
		# 	Coltest.saveThumb(self, self.img1, self.img1_thumb)

		# if self.img2 != self.__original_img2:
		# 	print(self.img2==None, self.__original_img2==None)
		# 	self.img2_datetime = timezone.now()
		super(Test, self).save( *args, **kwargs)

	def __str__(self):
		return (str)(self.id)

class TestImage(models.Model):
    test = models.ForeignKey(Test, on_delete=models.CASCADE)
    file_upload = models.FileField(upload_to='uploads/%Y/%m/%d/')
