from rest_framework import serializers
from .models import Test, TestImage
from django.utils.timezone import now
from django.db.transaction import atomic
from company.models import Company


class TestSerializer(serializers.ModelSerializer):
    days_since_created = serializers.SerializerMethodField()

    class Meta:
        model = Test
        fields = '__all__'


    def create(self, validated_data):
        print(validated_data['pdf'])
        test = Test()
        for i in validated_data:
            setattr(test, i, validated_data[i])
        # test = Test(
        #         created = validated_data.get('created', None),
        #         user = validated_data.get('user', None),
        #         title = validated_data.get('title', None),
        #         img1 = validated_data.get('img1', None),
        #         img1_thumb = validated_data.get('img1_thumb', None),
        #         img1_datetime = validated_data.get('img1_datetime', None),
        #         img2 = validated_data.get('img2', None),
        #         img2_datetime = validated_data.get('img2_datetime', None),
        #     )
        test.save(force_insert=True ,force_update=True, api='Create')
        for i in range(3):
            ti = TestImage()
            ti.test = test
            ti.file_upload = validated_data['img1']
            ti.save()
        return test

    def update(self, instance, validated_data):
        print(validated_data)
        instance.user = validated_data.get('user', instance.user)
        instance.title = validated_data.get('title', instance.title)
        instance.img1 = validated_data.get('img1', instance.img1)
        instance.img1_thumb = validated_data.get('img1_thumb', instance.img1_thumb)
        instance.img1_datetime = validated_data.get('img1_datetime', instance.img1_datetime)
        instance.img2 = validated_data.get('img2', instance.img2)
        instance.img2_datetime = validated_data.get('img2_datetime', instance.img2_datetime)
        instance.save(force_insert=False ,force_update=True, api='Update')
        return instance

    def get_days_since_created(self, obj):
        return (now() - obj.created).days


    # def update(self, instance, validated_data):
    #     """
    #     Update and return an existing `Snippet` instance, given the validated data.
    #     """
    #     instance.title = validated_data.get('title', instance.title)
    #     instance.code = validated_data.get('code', instance.code)
    #     instance.linenos = validated_data.get('linenos', instance.linenos)
    #     instance.language = validated_data.get('language', instance.language)
    #     instance.style = validated_data.get('style', instance.style)
    #     instance.save()
    #     return instance
