# Create your views here.
from django.core.files.uploadedfile import SimpleUploadedFile, InMemoryUploadedFile
from django.core.files.base import ContentFile
from django.utils import timezone

from .models import Test
from .serializers import TestSerializer

from rest_framework import viewsets
from rest_framework.permissions import IsAuthenticated

from PIL import Image
import os, random
from io import BytesIO
import base64
import string

def id_generator(size=6, chars=string.ascii_uppercase + string.digits):
    return ''.join(random.choice(chars) for _ in range(size)) + '.png'
# Create your views here.
class TestViewSet(viewsets.ModelViewSet):
    queryset = Test.objects.all()
    serializer_class = TestSerializer
    permission_classes = (IsAuthenticated,)
    def partial_update(self, instance, validated_data):
        pass
    def create(self, request):
        argsDict = ('img1',)
        mutable = request.data._mutable
        request.data._mutable = True
        print(request.data)
        for i in argsDict:
            if request.data[i] != '':
                if 'base64' in request.data[i] :
                    im = Image.open(BytesIO(base64.b64decode(request.data[i].split(';base64,')[1])))
                else:
                    im = Image.open(request.data[i])
                origin_image_io = BytesIO()
                im.save(origin_image_io, format=im.format)
                request.data[i] = SimpleUploadedFile(
                                        id_generator(),
                                        origin_image_io.getvalue(),
                                        'image/jpeg',
                                    )
            else:
                request.data.pop(i)
        request.data._mutable = mutable
        return super().create(request)
    def update(self, request, pk=None):
        argsDict = ('img1',)
        mutable = request.data._mutable
        request.data._mutable = True
        print(request.data)
        for i in argsDict:
            if request.data[i] != '':
                if 'base64' in request.data[i] :
                    im = Image.open(BytesIO(base64.b64decode(request.data[i].split(';base64,')[1])))
                else:
                    im = Image.open(request.data[i])
                origin_image_io = BytesIO()
                im.save(origin_image_io, format=im.format)
                request.data[i] = SimpleUploadedFile(
                                        id_generator(),
                                        origin_image_io.getvalue(),
                                        'image/jpeg',
                                    )
            else:
                request.data.pop(i)
        request.data._mutable = mutable
        return super().update(request)
    # def create(self, request):
    #     # argsDict = (('img1', 'img1_thumb', 'img1_datetime'), )
    #     # for i in argsDict:
    #     #     if request.data[i[0]] != '':
    #     #         origin_image_name = request.data[i[0]].name
    #     #         im = Image.open(request.data[i[0]])
    #     #         width = im.width
    #     #         height = im.height
    #     #         origin_image_io = BytesIO()
    #     #         im.save(origin_image_io, format=im.format)
    #     #         request.data[i[0]] = SimpleUploadedFile(
    #     #                 origin_image_name,
    #     #                 origin_image_io.getvalue(),
    #     #                 'image/jpeg',
    #     #          )
    #     #         if ((width/height)*205) > 145:
    #     #             newWidth = 145
    #     #             newHeight = 145 * (height/width)
    #     #         else:
    #     #             newHeight = 205
    #     #             newWidth  = (width/height) * 205
    #     #         new_image_io = BytesIO()
    #     #         new_image = im.resize(((int)(newWidth), (int)(newHeight)), Image.ANTIALIAS)
    #     #         new_image.save(new_image_io, format=im.format)
    #     #         request.data[i[1]] = SimpleUploadedFile(
    #     #                 origin_image_name,
    #     #                 new_image_io.getvalue(),
    #     #                 'image/jpeg',
    #     #          )
    #     return super().create(request)
from django.views.generic import ListView, CreateView, DetailView
from django.shortcuts import render, reverse, redirect, get_object_or_404
from django.views.generic.edit import UpdateView
from django.forms import formset_factory
from django.template import RequestContext
from django.http import HttpResponse, HttpResponseRedirect

from .forms import ColtestForm


# class ColtestUpdate(UpdateView):
#     model = Coltest
#     fields = ['title']
#     template_name_suffix = '_update_form'
#
# class ColtestCreate(CreateView):
#     model = Coltest
#     fields = ['title']
#     def get_success_url(self):
#             return redirect('coltest/')

class ColtestListView(ListView):
    queryset = Test.objects.all()
    template_name = "coltest/list.html"
    # def get_context_data(self, *args, **kwargs):
    #     context = super(ColtestListView, self).get_context_data(*args, **kwargs)
    #     print(context)
    #     return context
# class ColtestDetailView(DetailView):
#     queryset = Coltest.objects.all()
#     template_name = "coltest/detail.html"
#     # def get_context_data(self, *args, **kwargs):
#     #     context = super(ColtestListView, self).get_context_data(*args, **kwargs)
#     #     print(context)
#     #     return context
#
# def Coltest_update_view(request, pk=None, *argd, **kwargs):
#     #instance = Coltest.objects.get(pk=pk)
#     instance = get_object_or_404(Coltest, pk=pk)
#     image    = Images.objects.filter(obj=pk)
#     coltestForm = ColtestForm(request.POST or None, instance=instance)
#     img_data = [{'img': l.img}
#                     for l in image]
#     ImageFormSet = formset_factory(ImageForm, can_delete=True)
#     formset = ImageFormSet(initial=img_data)
#     if request.method == 'POST':
#         print (coltestForm.errors, formset.errors)
#         coltestForm = ColtestForm(request.POST or None, instance=instance)
#         formset = formset_factory(ImageForm, can_delete=True)(request.POST,request.FILES or None)
#         if coltestForm.is_valid() and formset.is_valid():
#             instance = coltestForm.save(commit=False)
#             instance.save()
#             for form in formset.cleaned_data:
#                 try:
#                     image = form['img']
#                     photo = Images(obj=coltestForm, img=image)
#                     photo.save()
#                 except:
#                     pass
#             for obj in formset.deleted_forms:
#                 try:
#                     image = form['img']
#                     photo = Images.objects.get(pk=image.pk)
#                     photo.delete()
#                 except:
#                     pass
#             return HttpResponseRedirect("/")
#         else:
#             print (coltestForm.errors, formset.errors)
#     context = {
#         'coltestForm': coltestForm,
#         'formset': formset,
#     }
#     return render(request, 'coltest/update.html', context)
#
# def Coltest_detail_view(request, pk=None, *argd, **kwargs):
#     #instance = Coltest.objects.get(pk=pk)
#     instance = get_object_or_404(Coltest, pk=pk)
#     image    = Images.objects.filter(obj=pk)
#     context = {
#         'object': instance,
#         'img': image
#     }
#     return render(request, 'coltest/detail.html', context)
#
# def coltest_list_view(request):
#     if request.method == 'POST':
#         if request.POST['action'] == "+":
#             extra = int(float(request.POST['extra'])) + 1
#             coltestForm = ColtestForm(request.POST)
#             formset = formset_factory(ImageForm, extra=extra)
#         else:
#             extra = int(float(request.POST['extra']))
#             coltestForm = ColtestForm(request.POST)
#             formset = formset_factory(ImageForm, extra=extra)(request.POST,request.FILES)
#             if coltestForm.is_valid() and formset.is_valid():
#                 coltestForm = coltestForm.save(commit=False)
#                 coltestForm.user = request.user
#                 coltestForm.save()
#
#                 for form in formset.cleaned_data:
#                     image = form['img']
#                     photo = Images(obj=coltestForm, img=image)
#                     photo.save()
#
#                 return HttpResponseRedirect("/")
#             else:
#                 print (coltestForm.errors, formset.errors)
#     else:
#         extra = 1
#         coltestForm = ColtestForm()
#         formset = formset_factory(ImageForm, extra=extra)
#     return render(request, 'coltest/coltest_list.html',
#                   {'extra':extra,'coltestForm': coltestForm, 'formset': formset},)
#
# # def coltest_list_view(request):
# #     queryset = Coltest.objects.all()
# #     context = {
# #         'object_list': queryset
# #     }
# #     return render(request,  "coltest/coltest_list.html", context)
